/*baat Project SDL*/

#define _CRT_SECURE_NO_WARNINGS  // For warning C4996: 'sprintf': This function or variable may be unsafe.
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>
#include <SDL/SDL_mixer.h>

//#include <SDL/SDL_draw.h>

//int mySDL_PollEvent(SDL_Event *event);
//экран 320х240
#define SCREEN_WIDTH  320
#define SCREEN_HEIGHT 240

#define      _pica    1
#define      _tref    2
#define      _buba    3
#define      _chirva  4

#define       _6      6
#define       _7      7
#define       _8      8
#define       _9      9
#define       _10     10
#define       _J      11
#define       _Q      12
#define       _K      13
#define       _A      14

#define       _non    3
#define       _play   1
#define       _comp   2

#define       _l      37
#define       _r      39
#define       _u      38
#define       _d      40
#define       _f      13

typedef struct cart {int n; int m;} cart;
typedef struct coloda {int count; cart all[36];} coloda;

coloda  all,comp,play,otboj,pole;
cart cozir;

int _set,_set_cart,_pred_cart,_win,net;     

//основной сурф, выводим на экран
SDL_Surface *g_pSurface = NULL;
//наши спрайты
SDL_Surface *g_pSprites = NULL;

const char *click_s = "data/click.wav";
const char *clock_s = "data/clock.wav";

int g_okQuit = 0; //выход не выбрали
int g_Volume = 50;
int qMus;

//вывести на экран сурф
void repaint() {SDL_Flip(g_pSurface);}
//пауза на d мс
void delay(int d) {SDL_Delay(d);}
//возвращает цвет в rgb
//Uint32 SetColor(int r,int g, int b) {return SDL_MapRGB(g_pSurface->format, r,g,b);}
//вывод прямоугольника
//void fillRect(int x,int y, int w, int h, Uint32 cColor) {SDL_Rect rc; rc.x=x;
//rc.y=y; rc.w=w; rc.h=h; SDL_FillRect(g_pSurface, &rc, cColor);}
//void drawLine(int x1, int y1, int x2, int y2, Uint32 cColor){Draw_Line(g_pSurface,x1,y1,x2,y2,cColor);}
//void drawRect(int x,int y, int w, int h, Uint32 cColor) {Draw_Rect(g_pSurface, x,y,w,h, cColor);}

//вывод куска из картинки(спрайта)
void DrawSprite(int x, int y, int spriteX, int spriteY, int spriteW, int spriteH) { 
    SDL_Rect src, dest; src.x=spriteX; src.y=spriteY; src.w=spriteW; src.h=spriteH;
    dest.x=x;  dest.y=y; dest.w=spriteW; dest.h=spriteH; SDL_BlitSurface(g_pSprites,&src,g_pSurface,&dest); }


void wr(int x, int y, int c) {  DrawSprite(x, y, 52+(c-1)*52, 300, 52, 17); }

void wr_cart(int x, int y, cart c) { DrawSprite(x, y, (c.n-_6)*55, (c.m-1)*75, 55, 75);}

void wr_rub(int x, int y) { DrawSprite(x, y, 0, 300, 52, 71); }


void cls() {int i;
            //  52,317
            for (i=0; i<6; i++)
                DrawSprite(0, i*40, 52, 317, 320, 40);
                    //fillRect(SetColor(0,0,0),0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
           }

int _random(int r) {return rand() % r;}

int min(int b) { int c; if (b+_6 <= _A) c=b+_6; else if (b+_6-9 <= _A) c=b+_6-9; else 
        if (b+_6-18 <= _A) c=b+_6-18; else c=b+_6-27; return c;}

void swp(int a,int b){cart c; c.n=all.all[a].n; c.m=all.all[a].m;
                      all.all[a].n=all.all[b].n; all.all[a].m=all.all[b].m;
                                        all.all[b].n=c.n; all.all[b].m=c.m;}

void mix() {int i; for (i=0; i<all.count; i++) {
        swp(_random(all.count),_random(all.count));
        swp(all.count-1,_random(all.count));}}

void raz_play() {
    while (play.count<6 && all.count>0) {
        if (all.count>0) {
            all.count--;
            play.all[play.count]=all.all[all.count];
            play.count++;}}}

void raz_comp() {
    while (comp.count<6 && all.count>0) {
        if (all.count>0) {
            all.count--;
            comp.all[comp.count]=all.all[all.count];
            comp.count++;}}}

void raz_all() { if (_set==_comp) { raz_comp(); raz_play(); } else { raz_play(); raz_comp(); }}

void _next() { if (_set==_comp) _set=_play; else _set=_comp; }

void newcoloda() { int i; _win=-1; net=0;
                   all.count=36; comp.count=0; play.count=0; _set_cart=2; _pred_cart=-1;
                                  for (i=0; i<all.count; i++) { all.all[i].m=i/9 + 1; all.all[i].n=min(i); }
                                                 comp.count=0; play.count=0; otboj.count=0; pole.count=0;
                                                                play.count=0; mix();
                                                                               cozir.n=all.all[0].n; cozir.m=all.all[0].m; _set=_play;}

void pr() {if (otboj.count==36) _win=_non; else
        if (all.count==0 && play.count==0) _win=_play; else
            if (all.count==0 && comp.count==0) _win=_comp;}

void to_otboj() {while (pole.count>0) {pole.count--;
        otboj.all[otboj.count].n=pole.all[pole.count].n;
        otboj.all[otboj.count].m=pole.all[pole.count].m; otboj.count++;} pr();}

void zabral_comp() { while (pole.count>0) {
        pole.count--;
        comp.all[comp.count].n=pole.all[pole.count].n;
        comp.all[comp.count].m=pole.all[pole.count].m;
        comp.count++;} pr(); }

int minimal(cart m) { int n=15, i, c=-1;
                      for (i=0; i<comp.count; i++)
                          if (comp.all[i].m==m.m)
                              if (comp.all[i].n<n && comp.all[i].n>m.n) {
                                  n=comp.all[i].n; c=i;} return c;}

void pole_play(int s) { cart temp; int i;
                        temp.n=play.all[s].n; temp.m=play.all[s].m;
                                            if (s!=play.count-1) {
                                                for (i=s+1; i<play.count; i++) {
                                                    play.all[i-1].n=play.all[i].n; play.all[i-1].m=play.all[i].m;}}
                                            pole.all[pole.count].n=temp.n; pole.all[pole.count].m=temp.m;
                                                                play.count--; pole.count++;
                                                                                    if (_set_cart>play.count-1) _set_cart=_set_cart-1;
                                                                                    if (comp.count==0 && all.count==0) to_otboj();
                      }

void pole_comp(int s) { cart temp; int i;
                        if (play.count>0) {
                            temp.n=comp.all[s].n; temp.m=comp.all[s].m;
                            if (s!=comp.count-1) {
                                for (i=s+1; i<comp.count; i++) {
                                    comp.all[i-1].n=comp.all[i].n; comp.all[i-1].m=comp.all[i].m;}}
                            pole.all[pole.count].n=temp.n; pole.all[pole.count].m=temp.m;
                            comp.count--; pole.count++; }}

int find(cart c) { int m=minimal(c); cart temp;
                   temp.n=_6; temp.m=cozir.m; if (m==-1) m=minimal(temp);
                   if (m!=-1) { if (c.m==comp.all[m].m && c.n>comp.all[m].n)
                           return -1; else return m;} else {return -1;}}

void hod_comp() {int a[4], i, mn, zn; cart t; 
                 if (play.count==0 && all.count==0) { } else
                     if (comp.count==1) { pole_comp(0); } else { zn=15; mn=-1;
                         for (i=_pica; i<_chirva+1; i++) { t.n=5; t.m=i;
                             if (i==cozir.m) { a[i-1]=-1; } else { a[i-1]=find(t);
                                 if (a[i-1]!=-1) if (comp.all[a[i-1]].n<zn) { zn=comp.all[a[i-1]].n; mn=a[i-1]; }}}
                         t.n=5; t.m=cozir.m; if (mn==15) mn=find(t); if (mn>-1) pole_comp(mn);}}

void otbiv_comp() { cart temp; int fd;
                    temp.n=pole.all[pole.count-1].n; temp.m=pole.all[pole.count-1].m;
                                    fd=find(temp); if (fd==-1) { net=1; } else {
                                        if (fd>-1) pole_comp(fd); }}

int hod_play_prov(cart a) { int res, i;
                            if (pole.count==0) { res=1; } else { res=0; for (i=0; i<pole.count; i++)
                                    if (pole.all[i].n==a.n) res=1;} return res;}

int proverka(int s) { int res=0;
                      if (pole.all[pole.count-1].m!=cozir.m) {
                          if ((play.all[s].m==pole.all[pole.count-1].m && play.all[s].n>pole.all[pole.count-1].n) || play.all[s].m==cozir.m) res=1;
                      } else { if (play.all[s].m==pole.all[pole.count-1].m && play.all[s].n>pole.all[pole.count-1].n) res=1; }
                                        return res;}

int next_comp(int b) { int i=0,r,s=-1; if (pole.count>0) 
        while (i<comp.count && s==-1) { for (r=0; r<pole.count; r++)
                if (pole.all[r].n==comp.all[i].n && comp.all[i].m!=cozir.m) s=i;i++; }
    if (s!=-1) { pole_comp(s); } else {
        if (!b) { to_otboj(); raz_all(); _next(); }}
                       if (s!=-1) return 0; else return 1; }

void zabral_play() { int b=0;
                     while (!b && comp.count>0) b=next_comp(1);
                                      while (pole.count>0) { pole.count--;
                                          play.all[play.count].n=pole.all[pole.count].n;
                                          play.all[play.count].m=pole.all[pole.count].m;
                                          play.count++;} pr(); }

void wr_play() { int i, delta; if (play.count>0) {
        if (play.count>6) delta=260 / play.count; else delta=310 / 6;
        for (i=0; i<play.count; i++)
            if (i!=_set_cart) wr_cart(5+i*delta, 160, play.all[i]);
        if (_set_cart!=-1) wr_cart(5+_set_cart*delta, 155, play.all[_set_cart]);}
    if (_win==-1) if (_set_cart==-1) wr(130,190,_set); }

void wr_pole() { int i, delta; if (pole.count>0) {
        if (pole.count>6) delta=170 / pole.count; else delta=220 / 6;
        for (i=0; i<pole.count; i++) wr_cart(5+i*delta, 80, pole.all[i]);}}

void wr_comp() { int i, delta; if (comp.count>0) {
        if (comp.count>6) delta=260 / comp.count; else delta=310 / 6;
        for (i=0; i<comp.count; i++) wr_rub(5+i*delta, 5); }}

void wr_coloda() { int c,i; if (all.count>0) { wr_cart(240, 80, cozir);
        if (all.count-1>4) c=4; else c=all.count-1;
        for (i=0; i<c+1; i++) wr_rub(255+i*2,85-i*2); }}

void _wrt() { cls(); wr_comp(); wr_pole(); wr_play(); wr_coloda();
              if (_win!=-1) wr(130,100, _win+2);  repaint();
            }

void stt() { newcoloda(); raz_all(); _wrt();}

void TKeyDown(int k) {
    int key=k;
    if (_win==-1) {
        if (play.count==1 && _set==_play && (key==_l || key==_r || key==_d || key==_u)) {
            if (_set_cart==0) _set_cart=-1; else _set_cart=0; key=0; } if (play.count>0) {
            if (key==_l) { if (_set_cart>0) _set_cart--; else _set_cart=play.count-1; }
            if (key==_r) { if (_set_cart<play.count-1) _set_cart++; else _set_cart=0; }
            if (pole.count>0) {
                if (key==_u || key==_d) {
                    if (play.count==1) {
                        _set_cart=0;
                    } else {
                        if (_set_cart==-1) {
                            _set_cart=_pred_cart;
                        } else {
                            _pred_cart=_set_cart; _set_cart=-1;
                        }
                    }
                }
            }
        }
        /////////////////////////////////////////////
        if (key==_f) {
            if (_set==_comp) {
                if (pole.count>0) {
                    if (_set_cart!=-1) {
                        if (proverka(_set_cart)) {
                            if (pole.count % 2!=0)
                                if (_set_cart!=-1)
                                    pole_play(_set_cart);
                            if (comp.count>0)
                                next_comp(0);
                        }
                    } else {
                        if (pole.count>0)
                            zabral_play();
                        raz_all();
                        if (comp.count>0) hod_comp();
                    }
                }
            } else if (_set==_play) {
                if (_set_cart!=-1) {
                    if (comp.count>0) {
                        if (hod_play_prov(play.all[_set_cart])) {
                            if (_set_cart!=-1)
                                pole_play(_set_cart);
                            if (!net) otbiv_comp();
                        } else {
                            // Empty o_O
                        }
                    } else {
                        to_otboj();
                        raz_all();
                        _next();
                        hod_comp();
                    }
                }
                else {
                    if (pole.count!=0) {
                        if (net) {
                            zabral_comp();
                            net=0;
                            raz_all();
                        } else {
                            raz_all();
                            to_otboj();
                            _next();
                            hod_comp();
                        }
                    }
                }
            }
        }
    } else {
        stt();
    }
    _wrt();
}

//int mySDL_PollEvent(SDL_Event *event) {
//    int __r= SDL_PollEvent(event);
//    if (!__r)
//        return 0;
//    if (event->type==SDL_ACTIVEEVENT) {
//        if (event->active.state==SDL_APPINPUTFOCUS && !event->active.gain) {
//            for (;;) {
//                __r=SDL_WaitEvent(event);
//                if (!__r)
//                    continue;
//                if(event->type==SDL_QUIT)
//                    return 1;
//                if(event->type!=SDL_ACTIVEEVENT)
//                    continue;
//                if (event->active.state==SDL_APPINPUTFOCUS && event->active.gain)
//                {
//                    return 1;
//                }
//            }
//        }
//    }
//    return __r;
//}

void PlaySound(const char *file) {
    Mix_Chunk *sample = Mix_LoadWAV(file);
    if (!sample) {
        printf ("Mix_LoadWAV: %s\n", Mix_GetError ());
    }

    Mix_PlayChannel(-1, sample, 0);
}

void PlayMusic(char *file, int chanel) {
    Mix_Music *music;
    music = Mix_LoadMUS(file);
    if (!music) {
        printf ("Mix_LoadMUS(\"*.*\"): %s\n", Mix_GetError ());
    }

    if (Mix_PlayMusic(music, chanel) == chanel) {
        printf ("Mix_PlayMusic: %s\n", Mix_GetError ());
    }
}

void MenuProcessEvent(SDL_Event evt) {
    if (evt.type==SDL_KEYDOWN) {
        int key=evt.key.keysym.sym, k;
        if (key==SDLK_LEFT||key==SDLK_RIGHT||key==SDLK_UP||key==SDLK_DOWN||key==SDLK_RETURN) {
            if (key==SDLK_LEFT) { k=_l; PlaySound(clock_s); }
            if (key==SDLK_RIGHT) { k=_r; PlaySound(clock_s); }
            if (key==SDLK_UP) { k=_u; PlaySound(clock_s); }
            if (key==SDLK_DOWN) { k=_d; PlaySound(clock_s); }
            if (key==SDLK_RETURN) { k=_f; PlaySound(click_s); }
            TKeyDown(k);
        }
        switch (key) {
        case SDLK_PAUSE:
            if (qMus) {
                Mix_HaltMusic();
                qMus = 0;
            } else {
                PlayMusic("data/music_aurora.mod", -1);
                qMus = 1;
            }
            break;
        case SDLK_MINUS:
            if (g_Volume >= 10) g_Volume -= 10;
            break;
        case SDLK_PLUS:
            if (g_Volume < 120) g_Volume += 10;
            break;
        case SDLK_ESCAPE:
            g_okQuit=1;
            break;
            // SELECT POWER UP on Dingoo
            //case SDLK_PLUS: case SDLK_MINUS: break;// A B on Dingoo

        default:
            break;
        } //по умолчанию нихрена не делать
    }
    //else if (evt.type == SDL_MOUSEBUTTONDOWN) {//нажата мышка... сенсор...
    //if(evt.button.button==SDL_BUTTON_LEFT) {}}//GameStart();

}

//инит случайных чисел 
void randomize() {srand(SDL_GetTicks());}
//загружаем спрайты
void LoadSprite() {SDL_Surface *temp; temp = SDL_LoadBMP("data/sprites.bmp");
                   if (temp==NULL) return; g_pSprites=SDL_DisplayFormat(temp); SDL_FreeSurface(temp);}

//инит графики
void InitGraph() { int flags=0; g_pSurface = SDL_SetVideoMode(SCREEN_WIDTH,SCREEN_HEIGHT,16,flags);
                   if (g_pSurface==NULL) return; SDL_ShowCursor(SDL_DISABLE);}

void InitSound () {
    if (SDL_Init (SDL_INIT_AUDIO) == -1) {
        printf ("SDL_Init: %s\n", SDL_GetError ());
        exit (1);
    }

    if (Mix_OpenAudio (44100, MIX_DEFAULT_FORMAT, 2, 1024) == -1) {
        printf ("Mix_OpenAudio: %s\n", Mix_GetError ());
        exit (2);
    }
}


int main(int argc, char *argv[]) {
    SDL_Event evt;
    randomize(); InitGraph(); InitSound(); LoadSprite();
    cls(); stt();

    SDL_WM_SetCaption("Durak by baat", NULL);
    SDL_WM_SetIcon(SDL_LoadBMP("data/durak_icon.bmp"), 0);

    PlayMusic("data/music_aurora.mod", -1);
    qMus = 1;

    while (!g_okQuit) {
        while (SDL_PollEvent(&evt)) {
            if (evt.type==SDL_QUIT) {
                g_okQuit = 1; break;
            } else {
                MenuProcessEvent(evt);
            }
        }
        Mix_VolumeMusic(g_Volume);
        //????????????????????
        //????????????????????
        //????????????????????
        //????????????????????

        //SDL_Delay(20);
    }

    SDL_FreeSurface(g_pSprites); //SDL_FreeSurface(g_pFont);
    SDL_Quit(); return 0;
}
